#only  task-specific loss
# only reference citation paper 160897,train citation paper 1562139,
# train paper 1562139,test paper 33644, only reference paper 160897, whole paper 1756680
import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse
import tensorflow as tf
import random
import math
import argparse
import input_tripledata
import PRJF1metric

datafile = '../../../DBLP_v8/'
datafile1 = '../'
datafile2 = '../EmbeddingGraph/TaskEmbedGraph/'
#datafile2 = '../EmbeddingGraph/GeneralEmbedGraph/'
#datafile2 = '../EmbeddingGraph/CombineEmbedGraph/'


embed_dim=128
t0=time.time()
# obtain author2id dict
author2id=dict()
tfile4 = open(datafile1+'DM_author.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	author2id[t2[1]]=int(t2[0])
tfile4.close()
# obtain id2testP dict
id2testP=dict()
testP2id=dict()
testPid_wordid=dict()
testPid_venueid=dict()
testPid_citationid=dict()
tfile4 = open(datafile1+'DM_test_paper.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	id2testP[int(t2[0])]=t2[1]
	testP2id[t2[1]]=int(t2[0])
	testPid_wordid[int(t2[0])]=list()
	testPid_citationid[int(t2[0])]=list()
tfile4.close()
print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
print '------------------get the testP_100candAuthor_dict and testP_100candAuthorid_dict-------------'
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(int(t2[1]))
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(author2id[t2[1]])
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()
print '------------------get the testP_100candAuthor_array and testP_100candAuthorid_array-------------'
testP_100candAuthor_array=spy.sparse.lil_matrix((162,100))
testP_100candAuthorid_array=spy.sparse.lil_matrix((162,100))
testP_orderAuthor10_array=spy.sparse.lil_matrix((162,10))
for i in range(0,162):
	testP_100candAuthor_array[i,:]=testP_100candAuthor_dict[id2testP[i]]
	testP_100candAuthorid_array[i,:]=testP_100candAuthorid_dict[id2testP[i]]
testP_100candAuthor_array=testP_100candAuthor_array.astype(int)
testP_100candAuthorid_array=testP_100candAuthorid_array.astype(int)
print testP_100candAuthor_array.shape
print testP_100candAuthorid_array.shape


print '------------------get the testP_wordid,-testP_venueid,testP_refenrenceid------------'
ALLpaper2id=dict()
#inf1 = open(datafile1+"id2onlyreference.txt","r")
#for line in inf1.readlines():
#	t2=line.strip().split('	')
#	ALLpaper2id[t2[1]]=int(t2[0])+1562139
inf1 = open(datafile1+"DM_trainpaper.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	ALLpaper2id[t2[1]]=int(t2[0])
wordindex2id=dict()
inf1 = open(datafile1+"DM_word.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	wordindex2id[t2[1]]=int(t2[0])
trainvenue2id=dict()
inf1 = open(datafile1+"DM_venue.txt","r")
for line in inf1.readlines():
	t2=line.strip().split('	')
	trainvenue2id[t2[1]]=int(t2[0])
print len(ALLpaper2id)
print len(wordindex2id)
print len(trainvenue2id)

inf6 = open(datafile1+"DM_test_p2o_final.txt","r")
for line in inf6.readlines():
	t2=line.strip().split('	')
	if t2[1] in wordindex2id:
		testPid_wordid[testP2id[t2[0]]].append(wordindex2id[t2[1]])
	if t2[1] in trainvenue2id:
		testPid_venueid[testP2id[t2[0]]]=trainvenue2id[t2[1]]
	if t2[1] in ALLpaper2id:
		testPid_citationid[testP2id[t2[0]]].append(ALLpaper2id[t2[1]])

print '------------------get author,word,year,venue,trainPRefP embedding array-------------'
author_emb=np.loadtxt(datafile2+"author_embedresult.txt")
word_emb=np.loadtxt(datafile2+"word_embedresult.txt")
#year_emb=np.loadtxt(datafile2+"year_embedresult.txt")
venue_emb=np.loadtxt(datafile2+"venue_embedresult.txt")
#trainp_emb=np.loadtxt(datafile2+"trainp_embedresult.txt")
weight=np.loadtxt(datafile2+"weight_result.txt")# word,venue,year,reference
print author_emb.shape
print word_emb.shape
#print year_emb.shape
print venue_emb.shape
#print trainp_emb.shape
print weight.shape
print weight
print weight[0]
testP_emb=spy.sparse.lil_matrix((162,embed_dim))
for i in range(0,162):
	wordmean=np.mean(word_emb[testPid_wordid[i],:],axis=0)
	venuemean=np.mean(venue_emb[testPid_venueid[i],:],axis=0)
	#refmean=np.mean(trainpRefp_emb[testPid_citationid[i],:],axis=0)
	#print venuemean.shape
	testP_emb[i,:]=weight[0]*wordmean+weight[1]*venuemean
for i in range(0,162):
	l=testP_100candAuthorid_array[i,:].todense()
	aemb=author_emb[l.tolist()[0],:]
	pemb=testP_emb[i,:].transpose()
	# PRODUCTION DOT
	aPmultiply=np.dot(aemb,pemb.todense())
	#Euclidean distance
	#temarry=np.square(aemb-np.tile(testP_emb[i,:].todense(),[aemb.shape[0],1]))
	#aPmultiply=np.sqrt(temarry.sum(axis=1))
	tem=(-aPmultiply.transpose()).argsort()
	testP_orderAuthor10_array[i,:]=testP_100candAuthor_array[i,tem.tolist()[0][0:10]].todense()

testP_orderAuthor10_dict={}# the top10 decrease order of 100 candidate authors
for i in range(0,162):
	#print testP_orderAuthor10_array[i,:].todense().astype(np.int32).tolist()[0]
	#print map(str,testP_orderAuthor10_array[i,:].todense().astype(np.int32).tolist()[0])
	testP_orderAuthor10_dict[id2testP[i]]=map(str,testP_orderAuthor10_array[i,:].todense().astype(np.int32).tolist()[0])
np.savetxt(datafile2+"testP_embedresult.txt",testP_emb.todense())
P_TOP3=list()
R_TOP3=list()
J_TOP3=list()
F1_TOP3=list()
MAP_TOP3=list()
P_TOP6=list()
R_TOP6=list()
J_TOP6=list()
F1_TOP6=list()
MAP_TOP6=list()
P_TOP10=list()
R_TOP10=list()
J_TOP10=list()
F1_TOP10=list()
MAP_TOP10=list()
print '---------------get the metric value---------'
k=3
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_orderAuthor10_dict,k)
P_TOP3.append(evaluresul[0])
R_TOP3.append(evaluresul[1])
J_TOP3.append(evaluresul[2])
F1_TOP3.append(evaluresul[3])
MAP_TOP3.append(evaluresul[4])
k=6
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_orderAuthor10_dict,k)
P_TOP6.append(evaluresul[0])
R_TOP6.append(evaluresul[1])
J_TOP6.append(evaluresul[2])
F1_TOP6.append(evaluresul[3])
MAP_TOP6.append(evaluresul[4])
k=10
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_orderAuthor10_dict,k)
P_TOP10.append(evaluresul[0])
R_TOP10.append(evaluresul[1])
J_TOP10.append(evaluresul[2])
F1_TOP10.append(evaluresul[3])
MAP_TOP10.append(evaluresul[4])
print len(testP_orderAuthor10_dict)
print 'P,R,J,F1,MAP values  (top-3)'
print P_TOP3
print R_TOP3
print J_TOP3
print F1_TOP3
print MAP_TOP3
print 'P,R,J,F1,MAP values (top-6)'
print P_TOP6
print R_TOP6
print J_TOP6
print F1_TOP6
print MAP_TOP6
print 'P,R,J,F1,MAP values  (top-10)'
print P_TOP10
print R_TOP10
print J_TOP10
print F1_TOP10
print MAP_TOP10
t9=time.time()
print 'time of only task-specific ranking result:'+str(t9-t0)
