import numpy as np
import time
from sklearn import preprocessing
import scipy as spy
from scipy import sparse

import PRJF1metric

t1=time.time()
datafile = '../../../DBLP_v8/'
datafile1 = '../'



print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()


# obtain author2id dict
author2id=dict()
tfile4 = open(datafile1+'DM_author.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	author2id[t2[1]]=int(t2[0])
tfile4.close()
# obtain id2testP dict
id2testP=dict()
tfile4 = open(datafile1+'DM_test_paper.txt','r')
for line in tfile4.readlines():
	t2=line.strip().split('	')
	id2testP[int(t2[0])]=t2[1]
tfile4.close()

print '------------------get the testP_100candAuthor_dict and testP_100candAuthorid_dict-------------'
testP_predA100_dict=dict()# predA100 is the top10 decrease order of 100 candidate authors
testP_100candAuthor_dict=dict()
testP_100candAuthorid_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[0] not in testP_100candAuthor_dict:
		testP_100candAuthor_dict[t2[0]]=list()
	testP_100candAuthor_dict[t2[0]].append(t2[1])
	if t2[0] not in testP_100candAuthorid_dict:
		testP_100candAuthorid_dict[t2[0]]=list()
	testP_100candAuthorid_dict[t2[0]].append(author2id[t2[1]])
	if t2[0] not in testP_predA100_dict:
		testP_predA100_dict[t2[0]]=list()
print len(testP_100candAuthor_dict)
print len(testP_100candAuthorid_dict)
infile2.close()

#obtain the matrix of PCPA
tfile1 = open(datafile1+'testPV3tuple.txt')
data1 = np.loadtxt(tfile1,delimiter='	')
row1=data1[:,0]
col1=data1[:,1]
d1=data1[:,2]
testPT=spy.sparse.csr_matrix((d1,(row1,col1)),shape=(162,5))
testPTRowNorm=preprocessing.normalize(testPT,norm='l1')

tfile = open(datafile1+'VtrainP3tuple.txt')
data = np.loadtxt(tfile,delimiter='	')
row=data[:,0]
print max(row)
col=data[:,1]
print max(col)
d=data[:,2]
TtrainP=spy.sparse.csr_matrix((d,(row,col)),shape=(5,8659))
#AT=A.transpose()
# normalize according to the row
TtrainPRowNorm=preprocessing.normalize(TtrainP,norm='l1') 


tfile2 = open(datafile1+'trainPA3tuple.txt')
data2 = np.loadtxt(tfile2,delimiter='	')
row=data2[:,0]
col=data2[:,1]
d=data2[:,2]
trainPA=spy.sparse.csr_matrix((d,(row,col)),shape=(8659,12660))
trainPARowNorm=preprocessing.normalize(trainPA,norm='l1')

print 'get the matrix of PCPA'
# resultdata means the final PCPA similarity matrix
resultdatatemp=np.dot(testPT,TtrainP) #pathcount
resultdata=np.dot(resultdatatemp,trainPA) #pathcount
#resultdatatemp=np.dot(testPTRowNorm,TtrainPRowNorm) #pcrw
#resultdata=np.dot(resultdatatemp,trainPARowNorm) #pcrw
# sort according to row
#resulindex=np.argsort(-resultdata.todense(),axis=1)
sizenum=resultdata.shape 
print 'the number of row , column of matrix PCPA'
print sizenum[0]
print sizenum[1]

resultdata100=spy.sparse.lil_matrix((sizenum[0],100))
for i in range(0,sizenum[0]):
	paperindex=id2testP[i]
	resultdata100[i,:]=resultdata[i,testP_100candAuthorid_dict[paperindex]]
	tem=np.argsort(-resultdata100[i,:].todense())
	for j in range(0,10):# 10 means whole 10 num in metric results
		#print tem[0,j]
		tempr=testP_100candAuthor_dict[paperindex][tem[0,j]]
		testP_predA100_dict[paperindex].append(tempr)

P_TOP3=list()
R_TOP3=list()
J_TOP3=list()
F1_TOP3=list()
MAP_TOP3=list()
P_TOP6=list()
R_TOP6=list()
J_TOP6=list()
F1_TOP6=list()
MAP_TOP6=list()
P_TOP10=list()
R_TOP10=list()
J_TOP10=list()
F1_TOP10=list()
MAP_TOP10=list()
RMSE3610=list()
print '---------------get the metric value---------'
k=3
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA100_dict,k)
P_TOP3.append(evaluresul[0])
R_TOP3.append(evaluresul[1])
J_TOP3.append(evaluresul[2])
F1_TOP3.append(evaluresul[3])
MAP_TOP3.append(evaluresul[4])
RMSE3610.append(evaluresul[5])
k=5
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA100_dict,k)
P_TOP6.append(evaluresul[0])
R_TOP6.append(evaluresul[1])
J_TOP6.append(evaluresul[2])
F1_TOP6.append(evaluresul[3])
MAP_TOP6.append(evaluresul[4])
RMSE3610.append(evaluresul[5])
k=10
evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA100_dict,k)
P_TOP10.append(evaluresul[0])
R_TOP10.append(evaluresul[1])
J_TOP10.append(evaluresul[2])
F1_TOP10.append(evaluresul[3])
MAP_TOP10.append(evaluresul[4])
RMSE3610.append(evaluresul[5])
print len(testP_predA100_dict)
print 'P,R,J,F1,MAP values  (top-3)'
print P_TOP3
print R_TOP3
print J_TOP3
print F1_TOP3
print MAP_TOP3
print 'P,R,J,F1,MAP values (top-5)'
print P_TOP6
print R_TOP6
print J_TOP6
print F1_TOP6
print MAP_TOP6
print 'P,R,J,F1,MAP values  (top-10)'
print P_TOP10
print R_TOP10
print J_TOP10
print F1_TOP10
print MAP_TOP10
t2=time.time()
print 'time :'+str(t2-t1)
print 'RMSE value of top 3, 5, 10:'
print RMSE3610
