import numpy as np
from sklearn.svm import LinearSVC
from sklearn.svm import SVR
from sklearn import preprocessing
from sklearn.preprocessing import MinMaxScaler
from sklearn import metrics
import matplotlib.pyplot as plt
from sklearn import linear_model, datasets
from sklearn.datasets import load_svmlight_file
import time
from sklearn.ensemble import RandomForestClassifier

import PRJF1metric

#datafile = '../../../DBLP_v8/'
#datafile2 = '../../DM_MIN_DATA/'
datafile1 = '../'
#index2namefile = '../../'
featNUM=17
# index2namefile + 'author2index.txt'
# index2namefile + 'word2index.txt'
# index2namefile + 'venue2index.txt'
# index2namefile + 'year2index.txt'
P_TOP3_diffRegul=list()
R_TOP3_diffRegul=list()
J_TOP3_diffRegul=list()
F1_TOP3_diffRegul=list()
MAP_TOP3_diffRegul=list()
P_TOP6_diffRegul=list()
R_TOP6_diffRegul=list()
J_TOP6_diffRegul=list()
F1_TOP6_diffRegul=list()
MAP_TOP6_diffRegul=list()
P_TOP10_diffRegul=list()
R_TOP10_diffRegul=list()
J_TOP10_diffRegul=list()
F1_TOP10_diffRegul=list()
MAP_TOP10_diffRegul=list()
t1=time.time()
print 'Load DM training data...'

trainfile = open('DM_train_feature.txt')
traindata = np.loadtxt(trainfile,delimiter='	')
train_x = traindata[:,:featNUM]
train_y = traindata[:,featNUM]# 0,1 label
print train_x.shape
print train_y.shape
scaler = MinMaxScaler()
scaler.fit(train_x)
MAXMINnormtrain_x=scaler.transform(train_x)
#print MAXMINnormtrain_x

print 'Load testing data...'

testfile = open('DM_test_feature.txt')
testdata = np.loadtxt(testfile,delimiter='	')
test_x = testdata[:,:featNUM]
test_y = testdata[:,featNUM]
print 'Test data pairs num:'
print test_x.shape
print test_y.shape
scaler.fit(test_x)
MAXMINnormtest_x=scaler.transform(test_x)
t11=time.time()
print 'get  train and test :'+str(t11-t1)

print '------------------get the testP_trueA_dict-------------'
testP_trueA_dict=dict()
infile2 = open(datafile1+'DM_test_p2a_final.txt','r')
for line in infile2.readlines():
	t2=line.strip().split('	')
	if t2[2]=='1':
		if t2[0] not in testP_trueA_dict:
			testP_trueA_dict[t2[0]]=list()
		testP_trueA_dict[t2[0]].append(t2[1])
print len(testP_trueA_dict)
infile2.close()
'''
print '------------------get the testP_trueA.txt file-------------'
outfile1 = open("testP_trueA.txt","w")
for i in testP_trueA_dict:
	outfile1.write(i+':')
	for j in testP_trueA_dict[i]:
		outfile1.write(j+'	')
	outfile1.write('\n')
'''
infile2 = open(datafile1+'DM_test_p2a_final100.txt','r')
tdata = np.loadtxt(infile2,delimiter='	')
testp_x = tdata[:,0]
testa_x = tdata[:,1]
#print testp_x.shape
#print type(testp_x[3])
#print testa_x.shape
# SVM,LR,RF,LambdaMart
#Cregul=[0.1,1,10,100,1000,10000,100000]
Cregul=[1]
t110=time.time()
for rc in Cregul:
	'''
	#C is the parameter of regularization,0.1,1,10,100,1000,10000,100000
	logreg = linear_model.LogisticRegression(C=rc)
	logreg.fit(MAXMINnormtrain_x,train_y)

	#logreg.predict_proba's Returns value : array-like, shape = [n_samples, n_classes]
	#predlabel = logreg.predict(MAXMINnormtest_x)
	predpro = logreg.predict_proba(MAXMINnormtest_x)
	'''
	'''
	# C is the penalty parameter of the error terms
	svm = LinearSVC(C=rc,tol=0.0001,loss='hinge')
	svm.fit(MAXMINnormtrain_x,train_y)
	predpro = svm.predict(MAXMINnormtest_x)
	'''
	'''
	svm = SVR(C=rc,epsilon=0.1)
	svm.fit(MAXMINnormtrain_x,train_y)
	predpro = svm.predict(MAXMINnormtest_x)
	print predpro
	print predpro.shape
	print type(predpro)
	print predpro[0:3]
	'''
	'''
	#n_estimators is the number of the trees in the forest
	rf=RandomForestClassifier(n_estimators=5, max_depth=2)
	rf.fit(MAXMINnormtrain_x,train_y)
	predpro=rf.predict_proba(MAXMINnormtest_x)
	print predpro
	
	'''
	reg = linear_model.BayesianRidge()
	reg.fit(MAXMINnormtrain_x,train_y)
	predpro=reg.predict(MAXMINnormtest_x)
	print predpro
	
	print '-------------get  testP_predA_dict---------------' 
	#get the second column proba value, and order these proba for each paper-author pair
	testP_predA_dict=dict() # predictive authors ordered by decrease of probality
	#num=len(predpro[:,1])
	num=len(predpro)
	print num
	eachnum=100
	count=0
	while count<=num-eachnum:
		#tem=np.argsort(-predpro[:,1][count:eachnum+count])
		tem=np.argsort(-predpro[count:eachnum+count])
		tempPaperID=str(int(testp_x[count]))
		testP_predA_dict[tempPaperID]=list()
		for i in range(0,len(tem)):
			testP_predA_dict[tempPaperID].append(str(int(testa_x[tem[i]+count])))
			#print predpro[:,1][tem[i]+count]
			#print str(predpro[:,1][tem[i]+count])
		count=count+eachnum
	print 'regulization C == '+str(rc)
	print '---------------get the metric value---------'
	k=3
	evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA_dict,k)
	P_TOP3_diffRegul.append(evaluresul[0])
	R_TOP3_diffRegul.append(evaluresul[1])
	J_TOP3_diffRegul.append(evaluresul[2])
	F1_TOP3_diffRegul.append(evaluresul[3])
	MAP_TOP3_diffRegul.append(evaluresul[4])
	k=6
	evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA_dict,k)
	P_TOP6_diffRegul.append(evaluresul[0])
	R_TOP6_diffRegul.append(evaluresul[1])
	J_TOP6_diffRegul.append(evaluresul[2])
	F1_TOP6_diffRegul.append(evaluresul[3])
	MAP_TOP6_diffRegul.append(evaluresul[4])
	k=10
	evaluresul=PRJF1metric.evalu(testP_trueA_dict,testP_predA_dict,k)
	P_TOP10_diffRegul.append(evaluresul[0])
	R_TOP10_diffRegul.append(evaluresul[1])
	J_TOP10_diffRegul.append(evaluresul[2])
	F1_TOP10_diffRegul.append(evaluresul[3])
	MAP_TOP10_diffRegul.append(evaluresul[4])
print len(testP_predA_dict)
print 'P,R,J,F1,MAP values with different regularization c=0.1,1,10,100,1000,10000,100000 are follows: (top-3)'
print P_TOP3_diffRegul
print R_TOP3_diffRegul
print J_TOP3_diffRegul
print F1_TOP3_diffRegul
print MAP_TOP3_diffRegul
print 'P,R,J,F1,MAP values with different regularization c=0.1,1,10,100,1000,10000,100000 are follows: (top-6)'
print P_TOP6_diffRegul
print R_TOP6_diffRegul
print J_TOP6_diffRegul
print F1_TOP6_diffRegul
print MAP_TOP6_diffRegul
print 'P,R,J,F1,MAP values with different regularization c=0.1,1,10,100,1000,10000,100000 are follows: (top-10)'
print P_TOP10_diffRegul
print R_TOP10_diffRegul
print J_TOP10_diffRegul
print F1_TOP10_diffRegul
print MAP_TOP10_diffRegul
 
t2=time.time()
print 'training 7 numbers(c=0.1,1,10,100,1000,10000,100000) time :'+str(t2-t110)

'''
print '-------------get  testP_predA.txt file---------------' 
outfile2 = open("testP_predA.txt","w")
for i in testP_predA_dict:
	outfile2.write(i+':')
	for j in testP_predA_dict[i]:
		outfile2.write(j+'	')
	outfile2.write('\n')
t3=time.time()
print 'get  testP_pred/trueA.txt filetime :'+str(t3-t2)
'''
